#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'tk_paradise/base/base.rb'
# =========================================================================== #
module Tk

class Base # === Tk::Base

  require 'colours'
  include Colours

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize(
      i = ARGV
    )
    set_commandline_arguments(i)
    reset
  end

  # ========================================================================= #
  # === reset                                                     (reset tag)
  # ========================================================================= #
  def reset
    # ======================================================================= #
    # === @internal_hash
    # ======================================================================= #
    @internal_hash = {}
  end

  # ========================================================================= #
  # === set_commandline_arguments
  # ========================================================================= #
  def set_commandline_arguments(i = '')
    i = [i].flatten.compact
    @commandline_arguments = i
  end

  # ========================================================================= #
  # === commandline_arguments?
  # ========================================================================= #
  def commandline_arguments?
    @commandline_arguments
  end

  # ========================================================================= #
  # === first_argument?
  # ========================================================================= #
  def first_argument?
    @commandline_arguments.first
  end; alias first? first_argument? # === first?

  # ========================================================================= #
  # === tk_variable
  # ========================================================================= #
  def tk_variable
    TkVariable.new
  end

end; end