require 'tk'

class PigBox

  # ========================================================================= #
  # === PADDING_TO_USE
  # ========================================================================= #
  PADDING_TO_USE = {
    padx: 10,
    pady: 10
  }

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize
    use_this_callback = proc { show_pig }
    root = TkRoot.new { title 'Pig' }
    top = TkFrame.new(root)
    TkLabel.new(top) {
      text 'Enter Text:'
      pack(PADDING_TO_USE)
    }
    @text = TkVariable.new
    @entry = TkEntry.new(top, textvariable: @text)
    @entry.pack(PADDING_TO_USE)
    TkButton.new(top) {
      text 'Pig It'
      command use_this_callback
      pack PADDING_TO_USE
    }
    TkButton.new(top) {
      text 'Exit'
      command {proc exit}
      pack PADDING_TO_USE
    }
    top.pack(fill: 'both', side: 'top')
  end

  # ========================================================================= #
  # === pig
  # ========================================================================= #
  def pig(word)
    leadingCap = word =~ /^A-Z/
    word.downcase!
    res =
    case word
    when /^aeiouy/
      "#{word}way"
    when /^([^aeiouy]+)(.*)/
      $2+$1+"ay"
    else
      word
    end
    leadingCap ? res.capitalize : res
  end

  # ========================================================================= #
  # === show_pig
  # ========================================================================= #
  def show_pig
    @text.value = @text.value.split.collect{|w| pig(w)}.join(' ')
  end

end

if __FILE__ == $PROGRAM_NAME
  PigBox.new
  Tk.mainloop
end