#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'tk'

# =========================================================================== #
# Demonstrates adding a vertical row of buttons to a scrolling canvas.
# =========================================================================== #
Tk.root.title('Test')
Tk.root.geometry('800x600+0+0')

canvas = TkCanvas.new(Tk.root) {
  width 320
  height 200
  scrollregion '0 0 400 400'
  pack(side: :left, fill: :both, expand: :true )
}

# =========================================================================== #
# Create the scrollbar next:
# =========================================================================== #
vbar = TkScrollbar.new(Tk.root) {
  orient 'vert'
  pack(side: :right, fill: :y)
}

canvas.yscrollbar(vbar)

frame = TkFrame.new(canvas) { |entry|
  (1 .. 12).each { |i|
    TkButton.new(entry) {
      text i
      command { Tk.bell }
      grid
    }
  }
}

TkcLine.new(canvas, 0, 0, 400, 400)
TkcLine.new(canvas, 0, 400, 400, 0)
TkcWindow.new(canvas, 200, 200, width: 100, height: 280, window: frame)

Tk.mainloop
