#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# tkpopup.rb : wrapper for tk_popup
# by Masahiro SATO (m@sa.to)
# Time-stamp: <99/08/14 10:49:28 msato>
# =========================================================================== #
require 'tk'

class TkPopup < TkWindow

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize(menu, x = 0, y = 0, entry = '')
    super()
    @menu = menu
    @x = x
    @y = y
    @entry = entry
    INTERP._eval('tk_popup '+
		 [@menu.path, @x.to_s, @y.to_s, @entry.to_s].join(' '))
  end
end

######################################################################
# example
# You will see a popup menu by clicking Button-3
######################################################################
if __FILE__ == $0
  color_ar = %w( blue yellow green pink grey )
  color = color_ar[0]

  TkRoot.new {|r|
    title File.basename($0)
    button = TkButton.new(r,
			  'text' => 'Quit',
			  "background" => color,
			  "activebackground" => "light " + color,
			  "command" => proc {r.destroy}
			  ).pack "fill"=>"both", "expand"=>"yes"

    menu = TkMenu.new(button, 'tearoff' => false)
    color_ar.each {|col|
      menu.add("command",
	       "label" => col,
	       "command" => proc {
		 color = col
		 button.background color
		 button.activebackground 'light '+color
	       }
	 )
    }

    button.bind("Button-3", proc {|x, y|
		  TkPopup.new(menu, x, y, color_ar.index(color))
		}, "%X %Y") # x_root and y_root
  }
  Tk.mainloop
end