#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'tk'

alias e puts

root = TkRoot.new
root.title = 'Combo Box Example'
root.geometry('700x550+0+0')

MONOSPACED_FONT = TkFont.new(family: 'Hack', size: 22, weight: 'bold')

# =========================================================================== #
# label text for title
# =========================================================================== #
TkLabel.new(root,
            text: 'Combobox Widget', 
            background: 'green',
            foreground: 'white',
            font:       MONOSPACED_FONT
           ).grid(row: 0, column: 0)

TkLabel.new(root,
            text:       'Select the month:',
            font:       MONOSPACED_FONT
           ).grid(column: 0, row: 5, padx: 10, pady: 25)

# =========================================================================== #
# Combobox creation:
# =========================================================================== #
n = TkVariable.new
combo_box = TkCombobox.new(
  root,
  width: 30,
  font:  MONOSPACED_FONT,
  textvariable: n
)
combo_box.values(%w(
  aa bb cc dd ee ff gg hh ii jj kk ll mm nn oo pp qq rr ss tt uu
))
combo_box.grid(column: 0, row: 6)
combo_box.current = 3

Tk.mainloop